package org.luis.security.recorder.ui;

import org.luis.security.recorder.main.VideoSource;
import org.luis.security.recorder.ui.util.JDialogEscape;
import java.io.File;
import javax.swing.JFileChooser;
import org.luis.security.recorder.ui.util.Observable;

/**
 *
 * @author luis
 */
public class DialogViewConfiguration extends JDialogEscape {

	Observable<VideoSource> source;
	boolean accepted = false;

	public DialogViewConfiguration(java.awt.Frame parent, Observable<VideoSource> source) {
		super(parent, true);
		initComponents();
		this.source = source;
		readParams();
		setLocationRelativeTo(parent);
	}

	public DialogViewConfiguration(java.awt.Dialog parent, Observable<VideoSource> source) {
		super(parent, true);
		initComponents();
		this.source = source;
		readParams();
		setLocationRelativeTo(parent);
	}

	public DialogViewConfiguration(java.awt.Frame parent) {
		super(parent, true);
		initComponents();
		readParams();
		setLocationRelativeTo(parent);
	}

	public DialogViewConfiguration(java.awt.Dialog parent) {
		super(parent, true);
		initComponents();
		readParams();
		setLocationRelativeTo(parent);
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        txtSource = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        lblFps1 = new javax.swing.JLabel();
        txtFps1 = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        chkSave = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        lblOutput = new javax.swing.JLabel();
        txtFile = new javax.swing.JTextField();
        btnFolderChooser = new javax.swing.JButton();
        jPanel9 = new javax.swing.JPanel();
        lblWriteFile = new javax.swing.JLabel();
        txtWriteMin = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jLabel2.setText("Source");

        txtSource.setText("rtsp://ip:port/options");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(5, 5, 5)
                .addComponent(txtSource, javax.swing.GroupLayout.DEFAULT_SIZE, 298, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtSource, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        getContentPane().add(jPanel2);

        lblFps1.setText("FPS (View and store)");

        txtFps1.setText("2");

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(txtFps1)
                    .addComponent(lblFps1, javax.swing.GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(lblFps1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtFps1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        getContentPane().add(jPanel6);

        chkSave.setText("Save");
        chkSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkSaveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(chkSave)
                .addContainerGap(247, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(chkSave)
                .addGap(10, 10, 10))
        );

        getContentPane().add(jPanel1);

        lblOutput.setText("Output");

        txtFile.setText("file://");

        btnFolderChooser.setText("...");
        btnFolderChooser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFolderChooserActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(lblOutput)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(txtFile, javax.swing.GroupLayout.DEFAULT_SIZE, 267, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnFolderChooser)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(lblOutput)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnFolderChooser))
                .addContainerGap())
        );

        getContentPane().add(jPanel3);

        lblWriteFile.setText("Swap file size (min)");

        txtWriteMin.setText("60");

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtWriteMin)
                    .addComponent(lblWriteFile, javax.swing.GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(lblWriteFile)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txtWriteMin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        getContentPane().add(jPanel9);

        jButton2.setText("Apply");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Cancel");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 148, Short.MAX_VALUE)
                .addComponent(jButton2)
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addContainerGap(28, Short.MAX_VALUE)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jButton3))
                .addContainerGap())
        );

        getContentPane().add(jPanel5);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void chkSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkSaveActionPerformed
		enableDisableSaveActions();
    }//GEN-LAST:event_chkSaveActionPerformed

    private void btnFolderChooserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnFolderChooserActionPerformed
		JFileChooser dlg = new JFileChooser(".");

		dlg.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		dlg.setMultiSelectionEnabled(false);

		int state = dlg.showOpenDialog(this);

		if (state != JFileChooser.APPROVE_OPTION) {
			this.txtFile.setText("");
			return;
		}

		File file = dlg.getSelectedFile();

		if (file == null) {
			this.txtFile.setText("");
			return;
		}

		if (!file.exists()) {
			file.mkdirs();
		}

		this.txtFile.setText(file.getAbsolutePath());
    }//GEN-LAST:event_btnFolderChooserActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
		applyParams();
		source.forceNotify();
		accepted = true;
		setVisible(false);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
		accepted = false;
		setVisible(false);
    }//GEN-LAST:event_jButton3ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnFolderChooser;
    private javax.swing.JCheckBox chkSave;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JLabel lblFps1;
    private javax.swing.JLabel lblOutput;
    private javax.swing.JLabel lblWriteFile;
    private javax.swing.JTextField txtFile;
    private javax.swing.JTextField txtFps1;
    private javax.swing.JTextField txtSource;
    private javax.swing.JTextField txtWriteMin;
    // End of variables declaration//GEN-END:variables

	private void ensureSource() {
		if (source == null) {
			source = new Observable<>(new VideoSource());
		} else if (source.get() == null) {
			source.set(new VideoSource(), false);
		}

	}

	private void readParams() {
		ensureSource();
		chkSave.setSelected(source.get().store);
		txtFile.setText(source.get().storeDir);

		txtSource.setText(source.get().url);
		txtFps1.setText(String.valueOf(source.get().fps == null ? "2" : source.get().fps));
		txtWriteMin.setText(String.valueOf(source.get().minutesToChangeFile == null ? "15" : source.get().minutesToChangeFile));
		enableDisableSaveActions();
	}

	private void applyParams() {
		ensureSource();

		VideoSource vs = source.get();
		vs.store = chkSave.isSelected();
		vs.storeDir = txtFile.getText();
		vs.fps = Integer.valueOf(txtFps1.getText());
		vs.url = txtSource.getText().trim();
		vs.minutesToChangeFile = Integer.valueOf(txtWriteMin.getText());

		source.set(vs, false);
	}

	public boolean isAccepted() {
		return accepted;
	}

	private void enableDisableSaveActions() {
		boolean isEnabled = chkSave.isSelected();
		txtFile.setEnabled(isEnabled);
		txtFps1.setEnabled(isEnabled);
		btnFolderChooser.setEnabled(isEnabled);
		lblOutput.setEnabled(isEnabled);
		lblWriteFile.setEnabled(isEnabled);
		txtWriteMin.setEnabled(isEnabled);
	}

}
